import { type Configuration, type BindingOptions } from "./type";
export type PublicApi = {
    addDates: (elementId: string, dates: Date[], type?: string, triggerRefresh?: boolean) => PublicApi;
    addDate: (elementId: string, date: Date, type?: string, triggerRefresh?: boolean) => PublicApi;
    updateDate: (elementId: string, date: Date, count: number, type?: string, triggerRefresh?: boolean) => PublicApi;
    removeDates: (elementId: string, dates: Date[], type?: string, triggerRefresh?: boolean) => PublicApi;
    removeDate: (elementId: string, date: Date, type?: string, triggerRefresh?: boolean) => PublicApi;
    clearDate: (elementId: string, date: Date, type?: string, triggerRefresh?: boolean) => PublicApi;
    resetAll: (triggerRefresh?: boolean) => PublicApi;
    reset: (elementId: string, triggerRefresh?: boolean) => PublicApi;
    import: (elementId: string, files: FileList) => PublicApi;
    export: (elementId: string, exportType?: string) => PublicApi;
    refresh: (elementId: string) => PublicApi;
    refreshAll: () => PublicApi;
    setYear: (elementId: string, year: number) => PublicApi;
    setYearToHighest: (elementId: string) => PublicApi;
    setYearToLowest: (elementId: string) => PublicApi;
    moveToPreviousYear: (elementId: string) => PublicApi;
    moveToNextYear: (elementId: string) => PublicApi;
    moveToCurrentYear: (elementId: string) => PublicApi;
    getYear: (elementId: string) => number;
    render: (element: HTMLElement, options: BindingOptions) => PublicApi;
    renderAll: () => PublicApi;
    switchView: (elementId: string, viewName: string) => PublicApi;
    switchType: (elementId: string, type: string) => PublicApi;
    updateOptions: (elementId: string, newOptions: BindingOptions) => PublicApi;
    destroyAll: () => PublicApi;
    destroy: (elementId: string) => PublicApi;
    setConfiguration: (newConfiguration: Configuration, triggerRefresh?: boolean) => PublicApi;
    getIds: () => string[];
    getVersion: () => string;
};
declare global {
    interface Window {
        $heat: PublicApi;
    }
}
