import { Is } from "./is";
export var Data;
(function (Data) {
    let String;
    (function (String) {
        function newGuid() {
            const result = [];
            for (let charIndex = 0; charIndex < 32; charIndex++) {
                if (charIndex === 8 || charIndex === 12 || charIndex === 16 || charIndex === 20) {
                    result.push("-");
                }
                const character = Math.floor(Math.random() * 16).toString(16);
                result.push(character);
            }
            return result.join("");
        }
        String.newGuid = newGuid;
        function padNumber(number) {
            const numberString = number.toString();
            return numberString.length === 1 ? "0" + numberString : numberString;
        }
        String.padNumber = padNumber;
        function startsWithAnyCase(data, start) {
            return data.substring(0, start.length).toLowerCase() === start.toLowerCase();
        }
        String.startsWithAnyCase = startsWithAnyCase;
    })(String = Data.String || (Data.String = {}));
    function getDefaultAnyString(value, defaultValue) {
        return typeof value === "string" ? value : defaultValue;
    }
    Data.getDefaultAnyString = getDefaultAnyString;
    function getDefaultString(value, defaultValue) {
        return Is.definedString(value) ? value : defaultValue;
    }
    Data.getDefaultString = getDefaultString;
    function getDefaultBoolean(value, defaultValue) {
        return Is.definedBoolean(value) ? value : defaultValue;
    }
    Data.getDefaultBoolean = getDefaultBoolean;
    function getDefaultNumber(value, defaultValue) {
        return Is.definedNumber(value) ? value : defaultValue;
    }
    Data.getDefaultNumber = getDefaultNumber;
    function getDefaultFunction(value, defaultValue) {
        return Is.definedFunction(value) ? value : defaultValue;
    }
    Data.getDefaultFunction = getDefaultFunction;
    function getDefaultArray(value, defaultValue) {
        return Is.definedArray(value) ? value : defaultValue;
    }
    Data.getDefaultArray = getDefaultArray;
    function getDefaultObject(value, defaultValue) {
        return Is.definedObject(value) ? value : defaultValue;
    }
    Data.getDefaultObject = getDefaultObject;
    function getDefaultStringOrArray(value, defaultValue) {
        let result = defaultValue;
        if (Is.definedString(value)) {
            const values = value.toString().split(" ");
            if (values.length === 0) {
                value = defaultValue;
            }
            else {
                result = values;
            }
        }
        else {
            result = getDefaultArray(value, defaultValue);
        }
        return result;
    }
    Data.getDefaultStringOrArray = getDefaultStringOrArray;
})(Data || (Data = {}));
//# sourceMappingURL=data.js.map