import { Data } from "./data";
export var DateTime;
(function (DateTime) {
    function getTotalDaysInMonth(year, month) {
        return new Date(year, month + 1, 0).getDate();
    }
    DateTime.getTotalDaysInMonth = getTotalDaysInMonth;
    function getWeekdayNumber(date) {
        return date.getDay() - 1 < 0 ? 6 : date.getDay() - 1;
    }
    DateTime.getWeekdayNumber = getWeekdayNumber;
    function getDayOrdinal(configuration, value) {
        let result = configuration.thText;
        if (value === 31 || value === 21 || value === 1) {
            result = configuration.stText;
        }
        else if (value === 22 || value === 2) {
            result = configuration.ndText;
        }
        else if (value === 23 || value === 3) {
            result = configuration.rdText;
        }
        return result;
    }
    DateTime.getDayOrdinal = getDayOrdinal;
    function getCustomFormattedDateText(configuration, dateFormat, date) {
        let result = dateFormat;
        const weekDayNumber = getWeekdayNumber(date);
        result = result.replace("{dddd}", configuration.dayNames[weekDayNumber]);
        result = result.replace("{dd}", Data.String.padNumber(date.getDate()));
        result = result.replace("{d}", date.getDate().toString());
        result = result.replace("{o}", getDayOrdinal(configuration, date.getDate()));
        result = result.replace("{mmmm}", configuration.monthNames[date.getMonth()]);
        result = result.replace("{mm}", Data.String.padNumber(date.getMonth() + 1));
        result = result.replace("{m}", (date.getMonth() + 1).toString());
        result = result.replace("{yyyy}", date.getFullYear().toString());
        result = result.replace("{yyy}", date.getFullYear().toString().substring(1));
        result = result.replace("{yy}", date.getFullYear().toString().substring(2));
        result = result.replace("{y}", parseInt(date.getFullYear().toString().substring(2)).toString());
        return result;
    }
    DateTime.getCustomFormattedDateText = getCustomFormattedDateText;
})(DateTime || (DateTime = {}));
//# sourceMappingURL=datetime.js.map